# BOUNDARIES
DROP TABLE IF EXISTS `mcm_boundaries`;
CREATE TABLE `mcm_boundaries` (
  `id` int(11) NOT NULL auto_increment,
  `typ` int(4)  NOT NULL,
  `country` int(6)  NOT NULL,
  `name` text collate utf8_bin NOT NULL,
  `lat1` int(11)  NOT NULL,
  `lon1` int(11)  NOT NULL,
  `lat2` int(11)  NOT NULL,
  `lon2` int(11)  NOT NULL,
  `polygon` longblob,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#SECTORS
DROP TABLE IF EXISTS `mcm_sectors`;
CREATE TABLE `mcm_sectors` (
  `id` int(11) NOT NULL auto_increment,
  `lat` int(11) NOT NULL default 0,
  `lon` int(11) NOT NULL default 0,
  `nodes` int(11) NOT NULL default 0,
  `segments` int(11) NOT NULL default 0,
  `turnsize` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `lat` (`lat`),
  KEY `lon` (`lon`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#NODES
DROP TABLE IF EXISTS `mcm_nodes`;
CREATE TABLE `mcm_nodes` (
  `id` int(11) NOT NULL auto_increment,
  `lat` int(11) NOT NULL default 0,
  `lon` int(11) NOT NULL default 0,
  `flags` int(11) NOT NULL default 0,
  `sector` int(11) NOT NULL default 0,
  `segments` int(11) NOT NULL default 0,
  `cross` text collate utf8_bin NOT NULL,
  `turns` int(11) NOT NULL default 0,
  `turn` text collate utf8_bin NOT NULL,
  `turnsize` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `sector` (`sector`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#PLANES
DROP TABLE IF EXISTS `mcm_planes`;
CREATE TABLE `mcm_planes` (
  `id` int(11) NOT NULL auto_increment,
  `sector` int(11)  NOT NULL,
  `typ` int(8)  NOT NULL,
  `lat1` int(11)  NOT NULL,
  `lon1` int(11)  NOT NULL,
  `lat2` int(11)  NOT NULL,
  `lon2` int(11)  NOT NULL,
  `polygon` longblob,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#PLANE SECTORS
DROP TABLE IF EXISTS `mcm_planes_sectors`;
CREATE TABLE `mcm_planes_sectors` (
  `id` int(11) NOT NULL auto_increment,
  `lat` int(11),
  `lon` int(11),
  `zoom` int(11),
  `planes` int(11) NOT NULL default 0,
  `size` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `lat` (`lat`),
  KEY `lon` (`lon`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#LOCATIONS
DROP TABLE IF EXISTS `mcm_loc`;
CREATE TABLE `mcm_loc` (
  `id` int(11) NOT NULL auto_increment,
  `sector` int(11)  NOT NULL,
  `typ` int(8)  NOT NULL,
  `lat` int(11)  NOT NULL,
  `lon` int(11)  NOT NULL,
  `name` int(11)  NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#LOCATIONS SECTORS
DROP TABLE IF EXISTS `mcm_loc_sectors`;
CREATE TABLE `mcm_loc_sectors` (
  `id` int(11) NOT NULL auto_increment,
  `lat` int(11),
  `lon` int(11),
  `locs` int(11) NOT NULL default 0,
  `size` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `lat` (`lat`),
  KEY `lon` (`lon`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#POI
DROP TABLE IF EXISTS `mcm_poi`;
CREATE TABLE `mcm_poi` (
  `id` int(11) NOT NULL auto_increment,
  `sector` int(11)  NOT NULL,
  `typ` int(8)  NOT NULL,
  `lat` int(11)  NOT NULL,
  `lon` int(11)  NOT NULL,
  `flags` int(11)  NOT NULL,
  `name` int(11)  NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#POI SECTORS
DROP TABLE IF EXISTS `mcm_poi_sectors`;
CREATE TABLE `mcm_poi_sectors` (
  `id` int(11) NOT NULL auto_increment,
  `lat` int(11),
  `lon` int(11),
  `pois` int(11) NOT NULL default 0,
  `size` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `lat` (`lat`),
  KEY `lon` (`lon`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#ADDRESSES
DROP TABLE IF EXISTS `mcm_country`;
CREATE TABLE `mcm_country` (
  `id` int(11) NOT NULL auto_increment,
  `size` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `mcm_city`;
CREATE TABLE `mcm_city` (
  `id` int(11) NOT NULL auto_increment,
  `country` int(11)  NOT NULL,
  `boundary` int(11)  NOT NULL,
  `typ` int(8)  NOT NULL,
  `lat` int(11)  NOT NULL,
  `lon` int(11)  NOT NULL,
  `name` int(11)  NOT NULL,
  `namec` text collate utf8_bin NOT NULL,
  `size` int(11) NOT NULL default 0,
  `sort` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `country` (`country`),
  KEY `boundary` (`boundary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `mcm_street`;
CREATE TABLE `mcm_street` (
  `id` int(11) NOT NULL auto_increment,
  `city` int(11)  NOT NULL,
  `lat` int(11)  NOT NULL,
  `lon` int(11)  NOT NULL,
  `name` int(11)  NOT NULL,
  `namec` text collate utf8_bin NOT NULL,
  `size` int(11) NOT NULL default 0,
  `sort` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `city` (`city`),
  KEY `sort` (`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `mcm_address`;
CREATE TABLE `mcm_address` (
  `id` int(11) NOT NULL auto_increment,
  `street` int(11)  NOT NULL,
  `lat` int(11)  NOT NULL,
  `lon` int(11)  NOT NULL,
  `name` int(11)  NOT NULL,
  `namec` text collate utf8_bin NOT NULL,
  `sort` int(11) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`),
  KEY `street` (`street`),
  KEY `sort` (`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `mcm_text`;
CREATE TABLE `mcm_text` (
  `id` int(11) NOT NULL auto_increment,
  `pos` int(11)  NOT NULL,
  `name` text collate utf8_bin NOT NULL,
  `note` text collate utf8_bin NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

#COASTLINES
DROP TABLE IF EXISTS `mcm_coastlines`;
CREATE TABLE `mcm_coastlines` (
  `id` int(11) NOT NULL auto_increment,
  `start` int(11)  NOT NULL,
  `stop` int(11)  NOT NULL,
  `polygon` longblob,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
