# CREATE DATABASE `osm` DEFAULT CHARACTER SET utf8 COLLATE utf8_bin

# NODES
DROP TABLE IF EXISTS `osm_nodes`;
CREATE TABLE `osm_nodes` (
  `id` int(11) NOT NULL,
  `lat` int(11),
  `lon` int(11),
  `used` int(1) NOT NULL default 0,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `osm_nodes_tags`;
CREATE TABLE `osm_nodes_tags` (
  `id` int(11) NOT NULL,
  `name` text collate utf8_bin NOT NULL,
  `val` text collate utf8_bin NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

# WAYS
DROP TABLE IF EXISTS `osm_ways`;
CREATE TABLE `osm_ways` (
  `id` int(11) NOT NULL,
  `nodes` longblob,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `osm_ways_tags`;
CREATE TABLE `osm_ways_tags` (
  `id` int(11) NOT NULL,
  `name` text collate utf8_bin NOT NULL,
  `val` text collate utf8_bin NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

# RELATIONS
DROP TABLE IF EXISTS `osm_relations`;
CREATE TABLE `osm_relations` (
  `id` int(11) NOT NULL,
  `members` longblob,
  PRIMARY KEY  (`id`),
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `osm_relations_tags`;
CREATE TABLE `osm_relations_tags` (
  `id` int(11) NOT NULL,
  `name` text collate utf8_bin NOT NULL,
  `val` text collate utf8_bin NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
