/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * globe.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ctype.h>
#include <string.h>
#include <stdio.h>


long min4(long l1, long l2, long l3, long l4)
{
  if (l2<l1) l1 = l2;
  if (l3<l1) l1 = l3;
  if (l4<l1) l1 = l4;
  return l1;
}

long max4(long l1, long l2, long l3, long l4)
{
  if (l2>l1) l1 = l2;
  if (l3>l1) l1 = l3;
  if (l4>l1) l1 = l4;
  return l1;
}

//return number bits set
long scan_bits(long i)
{
  long res = 0;
  int id=0;
  while (id<32)
  {
    if (i&0x1)
      res++;
    i = i >> 1;
    id++;
  }
  return res;
}

//return number of bits in most significant position from bit id
//in 0b01101 and id = 0 the result will be 2
long upper_bits(long i, long id)
{
  long res = 0;
  id++;
  i = i >> id;
  while (id<32)
  {
    if (i&0x1)
      res++;
    i = i >> 1;
    id++;
  }
  return res;
}

long strlong(char *s)
{
  long res = 0;
  if ((strlen(s) >= 2) && (s[0]=='0') && (s[1] == 'x'))
  {
    sscanf(s, "0x%lx", &res);
  }
  else
  {
    sscanf(s, "%ld", &res);
  }
  return res;
}

int is_inrect(long x, long y, long x1, long y1, long x2, long y2)
{
  if ((x>=x1) && (x<=x2) && (y>=y1) && (y<=y2))
    return 1;
  else
    return 0;
}

int is_rectinrect(long rx1, long ry1, long rx2, long ry2, long x1, long y1, long x2, long y2)
{
  long ax1 = rx1<rx2 ? rx1 : rx2;
  long ax2 = rx1>rx2 ? rx1 : rx2;
  long ay1 = ry1<ry2 ? ry1 : ry2;
  long ay2 = ry1>ry2 ? ry1 : ry2;

  if (ax2<x1)
    return 0;
  if (ax1>x2)
    return 0;
  if (ay2<y1)
    return 0;
  if (ay1>y2)
    return 0;
  
  return 1;
}


int strcasepos(char *str, char *needle)
{
  int i = 0;
  int start = 0;
  int valid = 0;
  char *n;
  if ((needle==NULL) || (*needle == 0))
    return -1;
  n = needle;
  while (*str!=0)
  {
    int chi = *str;
    char ch = tolower(chi);
    //ignore non-alphanumeric characters
    if (((ch>='a') && (ch<='z')) || ((ch>='0') && (ch<='9')))
    {
      chi = *n;
      if (ch == tolower(chi))
      {
        if (n==needle)
          start = valid;
        n++;
      }
      else
      {
        start = valid;
      }
      valid++;
    }
    
    if (*n == 0)
      return start;
    i++;
    str++;
  }
  return -1;
}

int nice_dist(char *s, long meters, int rounding)
{
  if (meters>=1000000)
    sprintf(s, "%ldkm", meters/1000);
  else if (meters>=10000)
    sprintf(s, "%ld km", meters/1000);
  else if (meters>=1000)
    sprintf(s, "%ld.%ld km", meters/1000, meters/100%10);
  else
    sprintf(s, "%ld m", meters/rounding*rounding);
  return 0;
}

int country_code(char *country)
{
  //to lowercase
  char *s = country;
  while (*s != 0)
  {
    int chi = *s;
    *s = tolower(chi);
    s++;
  }
  if (strcmp(country, "cz") == 0) return 420;
  return 0;
}
