/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * mcthread.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MCTHREAD_H
#define _MCTHREAD_H

#include <pthread.h>
#include <semaphore.h>

//thread
typedef pthread_t mcthread;
int mcthread_create(mcthread *thread, void *(*start_routine)(void*), void *arg, int nice);
int mcthread_join(mcthread *thread);

//mutex
typedef pthread_mutex_t mcmutex;

int mcmutex_init(mcmutex *mutex);
int mcmutex_destroy(mcmutex *mutex);
int mcmutex_lock(mcmutex *mutex);
int mcmutex_unlock(mcmutex *mutex);

//semaphore
typedef sem_t mcsema;

int mcsema_init(mcsema *sema);
int mcsema_destroy(mcsema *sema);
int mcsema_signal(mcsema *sema);
int mcsema_wait(mcsema *sema);
int mcsema_waittimed(mcsema *sema, long miliseconds);

#endif
