/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * mctime.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "mctime.h"
#include <stdio.h>


void create_timer(char *s, struct timeval *start, struct timeval *stop)
{
  long mtime, hours, minutes, seconds, miliseconds, useconds;
  seconds = stop->tv_sec - start->tv_sec;
  useconds = stop->tv_usec - start->tv_usec;
  mtime = seconds * 1000 + useconds/1000;
  hours = mtime / 3600000;
  mtime -= hours * 3600000;
  minutes = mtime / 60000;
  mtime -= minutes * 60000;
  seconds = mtime / 1000;
  miliseconds = mtime - seconds * 1000;
  if (hours)
    sprintf(s, "%02ld:%02ld:%02ld", hours, minutes, seconds);
  else
    sprintf(s, "%02ld:%02ld.%03ld", minutes, seconds, miliseconds);
}

//start the timer
void timer_start(struct timeval *time)
{
  gettimeofday(time, NULL);
}

//return timer in miliseconds
long timer_get(struct timeval *start)
{
  long seconds, useconds;
  struct timeval stop;
  gettimeofday(&stop, NULL);
  seconds = stop.tv_sec - start->tv_sec;
  useconds = stop.tv_usec - start->tv_usec;
  useconds = seconds*1000 + useconds/1000;
  return useconds;
}

//print the timer value to stdout
void timer_print(struct timeval *start)
{
  char s[100];
  struct timeval time_cur;
  gettimeofday(&time_cur, NULL);
  create_timer(s, start, &time_cur);
  printf("%s \n",s);
}

void timer_sprint(char *s, struct timeval *start)
{
  struct timeval time_cur;
  gettimeofday(&time_cur, NULL);
  create_timer(s, start, &time_cur);
}
