/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_polygon.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPPOLYGON_H
#define _MCMAPPOLYGON_H

#include <map.h>

typedef struct
{
  int count;
  map_multipolygon *mp[];
} map_multipolygons;

int map_polygonarea(map_polygon *polygon, long *lat1, long *lon1, long *lat2, long *lon2);
long map_multipolygonsize(map_multipolygon *mp);

int map_pointinpolygon(map_position *pos, map_polygon *poly);
int map_pointinmultipolygon(map_position *pos, map_multipolygon *mp);
int map_polygoninpolygon(map_polygon *inner, map_polygon *outer);
int map_polygoncrosspolygon(map_polygon *inner, map_polygon *outer);
int map_polygonselfcross(map_polygon *polygon);
map_polygon *map_polygonclockwise(map_polygon *polygon, int counterclockwise = 0);

int map_multipolygons_split(map_multipolygon *mp, int *count, map_multipolygon ***mps);

char *polygon2ascii(map_polygon *polygon);
map_polygon *ascii2polygon(unsigned char *arr);
char *multipolygon2ascii(map_multipolygon *mp);
map_multipolygon *ascii2multipolygon(const char *arr);

map_polygon *map_newpolygon(int count);
map_multipolygon *map_newmultipolygon(int count);
map_multipolygons *map_newmultipolygons(int count);
map_polygon *map_duplicatepolygon(map_polygon *poly);
map_multipolygon *map_duplicatemultipolygon(map_multipolygon *mp);
map_multipolygons *map_duplicatemultipolygons(map_multipolygons *mps);

int map_freepolygon(map_polygon *p);
int map_freemultipolygon(map_multipolygon *mp);
int map_freemultipolygons(map_multipolygons *mp);

map_multipolygons *load_multipolygons(const char *filename);
int save_polygon(map_polygon *polygon, const char *filename);

#endif
