/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * globe.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PROJECTION_H
#define _PROJECTION_H

#define pi 3.1415926535897932384626433832795
#define earthRadius 6378137

//latitude and longitude are long int * 1 000 000 so lat=1.0 -> 1 000 000
//distances are in meters

int wgs84_latradius(long lat);
long wgs84_latangle(long distance);
long wgs84_lonangle(long lat, long distance);
int wgs84_compare(long lat1, long lon1, long lat2, long lon2);
int wgs84_distance(long lat1, long lon1, long lat2, long lon2);
int wgs84_distance_mm(long lat1, long lon1, long lat2, long lon2);
double wgs84_distance_f(double lat1, double lon1, double lat2, double lon2);
int wgs84_angle(long lat1, long lon1, long lat2, long lon2);
double wgs84_angle_f(double lat1, double lon1, double lat2, double lon2);
int wgs84_waydistance(long lat, long lon, long lat1, long lon1, long lat2, long lon2);
int wgs84_waysection(long lat, long lon, long lat1, long lon1, long lat2, long lon2);
int wgs84_waysnap(long lat, long lon, long lat1, long lon1, long lat2, long lon2, long *lats, long *lons, int *distance, int *section1, int *section2);
int wgs84_cross(long lat1, long lon1, long lat2, long lon2, long lat3, long lon3, long lat4, long lon4, long *lats, long *lons);

void wgs84_pos2screen(long lat, long lon, long zero_lat, long zero_lon, int zero_angle, long *x, long *y);
void wgs84_screen2pos(long x, long y, long zero_lat, long zero_lon, int zero_angle, long *lat, long *lon);

#endif
