/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * globe.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "safefile.h"
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>

FILE *fsafeopen(const char *filename , const char *opentype )
{
  FILE *f = NULL;
  char s[255];
  if (((f = fopen(filename, opentype)) == NULL) && (strpbrk(opentype, "w") != NULL))
  {
    //try to create directory
    char *dir = (char *) malloc(strlen(filename)+1);
    strcpy(dir, filename);
    char *d;
    if ((d = strrchr(dir, '/')) != NULL)
    {
      *d = 0;
      if (mkdir(dir, S_IRWXU | S_IRWXG | S_IROTH) == 0)
      {
        f = fopen(filename, opentype);
      }
    }
    free(dir);
  }
  return f;
}
