/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * typeio.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _TYPEIO_H
#define _TYPEIO_H

#include <stdio.h>

//read from file the correct size and order
size_t fwrite_long(const long *data, size_t count, FILE *stream);
size_t fwrite_ulong(const unsigned long *data, size_t count, FILE *stream);
size_t fwrite_int(const int *data, size_t count, FILE *stream);
size_t fwrite_uint(const unsigned int *data, size_t count, FILE *stream);
size_t fwrite_char(const char *data, size_t count, FILE *stream);
size_t fwrite_uchar(const unsigned char *data, size_t count, FILE *stream);
size_t fread_long(long *data, size_t count, FILE *stream);
size_t fread_ulong(unsigned long *data, size_t count, FILE *stream);
size_t fread_int(int *data, size_t count, FILE *stream);
size_t fread_uint(unsigned int *data, size_t count, FILE *stream);
size_t fread_char(char *data, size_t count, FILE *stream);
size_t fread_uchar(unsigned char *data, size_t count, FILE *stream);

//read from memory buffer and increase memory pointer by correct size
long read_long(char **data);
unsigned long read_ulong(char **data);
int read_int(char **data);
unsigned int read_uint(char **data);
char read_char(char **data);
unsigned char read_uchar(char **data);
void read_string(char **data, char *s, int len);


#endif
