/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * draw_imlib2.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <Imlib2.h>

typedef struct
{
  int x;
  int y;
} drw_pos;

typedef Imlib_Font drw_font;
typedef Imlib_Image drw_image;

//init
void draw_init();
void draw_deinit();

//create & destroy
drw_image draw_create(int width, int height);
void draw_destroy(Imlib_Image img);

void draw_setcolor(long color);

//font
drw_font draw_loadfont(char *fontname);
void draw_freefont(drw_font font);
void draw_setfont(drw_font font);

//draw graphics
void draw_line(drw_image img, int x1, int y1, int x2, int y2, int width);
void draw_rectangle(drw_image img, int x1, int y1, int x2, int y2, int fill);
void draw_polygon(drw_image img, drw_pos *poly, int count, int fill);
void draw_blend(drw_image img, drw_image blend, int x, int y, int w, int h);

//draw text
void draw_text(drw_image img, int x, int y, int valign, int halign, double angle, char *text);
int  draw_text_width(drw_image img, char *text);

//load & save
drw_image draw_loadimage(char *path);

//image functions
void draw_getsize(drw_image img, int *width, int *height);
int *draw_getdata(drw_image img);

