/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * gui_progress.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <Evas.h>
#include <Ecore.h>
#include <Ecore_Evas.h>
#include <Edje.h>
#include <string.h>
#include "mcconf.h"
#include "gui_progress.h"


Evas_Object *edje_prg = NULL;
int edje_prg_w, edje_prg_h;


void gui_prg_show(Evas *evas, int x, int y, int width, int height)
{
  if (edje_prg == NULL)
  {
    edje_prg = edje_object_add(evas);
    char *edjefile = (char*)malloc(strlen(config->datadir) + 30);
    sprintf(edjefile, "%s/themes/Default/main.edj", config->datadir);
    edje_object_file_set(edje_prg, edjefile, "menu_prg");
    free(edjefile);
    evas_object_move(edje_prg, x, y);
    evas_object_resize(edje_prg, width, height);
    edje_prg_w = width;
    edje_prg_h = height;
    //edje_object_signal_callback_add(edje_prg, "*", "but", butpress, NULL);
  }
  evas_object_show(edje_prg);
}

void gui_prg_resize(int x, int y, int width, int height)
{
  if (edje_prg)
  {
    evas_object_move(edje_prg, x, y);
    evas_object_resize(edje_prg, width, height);
    edje_prg_w = width;
    edje_prg_h = height;
  }
}

void gui_prg_hide(void)
{
  evas_object_hide(edje_prg);
}

void gui_prg_free(void)
{
  if (edje_prg != NULL)
  {
    evas_object_del(edje_prg);
    edje_prg = NULL;
  }
}

void gui_prg_set(int progress, char *text)
{
  if (edje_prg != NULL)
  {
    char s[30];
    int x, y, w, h;
    snprintf(s, sizeof(s), "%d %%", progress);
    edje_object_part_text_set(edje_prg, "progress_percent", s);
    edje_object_part_text_set(edje_prg, "progress_text", text);
    evas_object_geometry_get(edje_prg, &x, &y, &w, &h);
    Evas_Object *bar = (Evas_Object *)edje_object_part_object_get(edje_prg, "progress_bar");
    evas_object_resize(bar, edje_prg_w*progress/100, edje_prg_h/2);
  }
}

