/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * main.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include "mcconf.h"
#include "map_read.h"
#include "route.h"
#include "gui.h"
#include "mctime.h"

int main(int argc, char **argv)
{
  int result;
  if (conf_init(argc, argv) != 0)
  {
    printf("Cannot read configuration\n");
    return -1;
  }
  
  if (map_open(config->map)<0)
  {
    conf_deinit();
    printf("Cannot open map\n");
    return -1;
  }

  gui_init(argc, argv);
  result = gui_start();
  map_close();
  conf_deinit();
  printf("Good bye!\n");
  return result;
}
