/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_styles.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "mcconf.h"
#include "functions.h"
#include "map_styles.h"
#include <map.h>

#define PS_ROUTE -2

maptypes gettype(char *way)
{
  if (strcmp(way, "motorway") == 0) return WT_MOTORWAY;
  if (strcmp(way, "motorway_link") == 0) return WT_MOTORWAYLINK; 
  if (strcmp(way, "trunk") == 0) return WT_TRUNK;
  if (strcmp(way, "trunk_link") == 0) return WT_TRUNKLINK;
  if (strcmp(way, "primary") == 0) return WT_PRIMARY;
  if (strcmp(way, "primary_link") == 0) return WT_PRIMARYLINK;
  if (strcmp(way, "secondary") == 0) return WT_SECONDARY;
  if (strcmp(way, "secondary_link") == 0) return WT_SECONDARY;
  if (strcmp(way, "tertiary") == 0) return WT_TERTIARY;
  if (strcmp(way, "unclassified") == 0) return WT_UNCLASSIFIED;
  if (strcmp(way, "residential") == 0) return WT_RESIDENTIAL;
  if (strcmp(way, "living_street") == 0) return WT_LIVING;
  if (strcmp(way, "pedestrian") == 0) return WT_LIVING;
  if (strcmp(way, "service") == 0) return WT_SERVICE;
  if (strcmp(way, "cycle") == 0) return WT_CYCLE;
  if (strcmp(way, "bridle") == 0) return WT_BRIDLE;
  if (strcmp(way, "track1") == 0) return WT_TRACK1;
  if (strcmp(way, "track2") == 0) return WT_TRACK2;
  if (strcmp(way, "track3") == 0) return WT_TRACK3;
  if (strcmp(way, "track4") == 0) return WT_TRACK4;
  if (strcmp(way, "track5") == 0) return WT_TRACK5;
  if (strcmp(way, "path") == 0) return WT_PATH;
  if (strcmp(way, "foot") == 0) return WT_FOOT;
  if (strcmp(way, "steps") == 0) return WT_STEPS;
  if (strcmp(way, "ferry") == 0) return WT_FERRY;

  if (strcmp(way, "rail") == 0) return NT_RAIL;
  if (strcmp(way, "tram") == 0) return NT_TRAM;
  if (strcmp(way, "runway") == 0) return NT_RUNWAY;
  if (strcmp(way, "powerline") == 0) return NT_POWERLINE;
  if (strcmp(way, "pier") == 0) return NT_PIER;
  if (strcmp(way, "weir") == 0) return NT_WEIR;
  if (strcmp(way, "river") == 0) return NT_RIVER;
  if (strcmp(way, "stream") == 0) return NT_STREAM;
  if (strcmp(way, "wall") == 0) return NT_WALL;
  if (strcmp(way, "fence") == 0) return NT_FENCE;
  if (strcmp(way, "boundary") == 0) return NT_BOUNDARY;

  if (strcmp(way, "city") == 0) return POI_CITY;
  if (strcmp(way, "town") == 0) return POI_TOWN;
  if (strcmp(way, "village") == 0) return POI_VILLAGE;
  if (strcmp(way, "hamlet") == 0) return POI_HAMLET;
  if (strcmp(way, "suburb") == 0) return POI_SUBURB;
  if (strcmp(way, "locality") == 0) return POI_LOCALITY;
  
  if (strcmp(way, "fuel") == 0) return POI_FUEL;
  if (strcmp(way, "pub") == 0) return POI_PUB;
  if (strcmp(way, "restaurant") == 0) return POI_RESTAURANT;
  if (strcmp(way, "fastfood") == 0) return POI_FASTFOOD;
  if (strcmp(way, "cafe") == 0) return POI_CAFE;
  if (strcmp(way, "icecream") == 0) return POI_ICECREAM;
  if (strcmp(way, "tee") == 0) return POI_TEE;
  if (strcmp(way, "tower") == 0) return POI_TOWER;
  if (strcmp(way, "fountain") == 0) return POI_FOUNTAIN;
  if (strcmp(way, "recycling") == 0) return POI_RECYCLING;
  if (strcmp(way, "toilets") == 0) return POI_TOILETS;
  if (strcmp(way, "postbox") == 0) return POI_POSTBOX;
  if (strcmp(way, "camp") == 0) return POI_CAMP;
  if (strcmp(way, "phone") == 0) return POI_PHONE;
  if (strcmp(way, "atm") == 0) return POI_ATM;
  if (strcmp(way, "bus") == 0) return POI_BUS;
  if (strcmp(way, "tramstop") == 0) return POI_TRAM;
  if (strcmp(way, "trainstop") == 0) return POI_TRAIN;
  if (strcmp(way, "airport") == 0) return POI_AIRPORT;
  if (strcmp(way, "ford") == 0) return POI_FORD;
  if (strcmp(way, "address") == 0) return POI_ADDRESS;

  if (strcmp(way, "tree") == 0) return POI_TREE;
  if (strcmp(way, "stone") == 0) return POI_STONE;
  if (strcmp(way, "peak") == 0) return POI_PEAK;
  if (strcmp(way, "powertower") == 0) return POI_POWERTOWER;
  if (strcmp(way, "powergenerator") == 0) return POI_POWERGENERATOR;
  
  if (strcmp(way, "hotel") == 0) return POI_HOTEL;
  if (strcmp(way, "church") == 0) return POI_CHURCH;
  if (strcmp(way, "firestation") == 0) return POI_FIRESTATION;
  if (strcmp(way, "museum") == 0) return POI_MUSEUM;
  if (strcmp(way, "historic") == 0) return POI_HISTORIC;
  if (strcmp(way, "hospital") == 0) return POI_HOSPITAL;
  if (strcmp(way, "doctors") == 0) return POI_DOCTORS;
  if (strcmp(way, "postoffice") == 0) return POI_POSTOFFICE;
  if (strcmp(way, "shop") == 0) return POI_SHOP;
  if (strcmp(way, "school") == 0) return POI_SCHOOL;
  if (strcmp(way, "bank") == 0) return POI_BANK;
  if (strcmp(way, "police") == 0) return POI_POLICE;
  if (strcmp(way, "pharmacy") == 0) return POI_PHARMACY;
  if (strcmp(way, "townhall") == 0) return POI_TOWNHALL;
  if (strcmp(way, "prison") == 0) return POI_PRISON;
  if (strcmp(way, "shelter") == 0) return POI_SHELTER;
  
  if (strcmp(way, "building") == 0) return PT_BUILDING;
  if (strcmp(way, "playground") == 0) return PT_PLAYGROUND;
  if (strcmp(way, "pitch") == 0) return PT_PITCH;
  if (strcmp(way, "marsh") == 0) return PT_MARSH;
  if (strcmp(way, "water") == 0) return PT_WATER;
  if (strcmp(way, "swimmingpool") == 0) return PT_SWIMMINGPOOL;
  if (strcmp(way, "basin") == 0) return PT_BASIN;
  if (strcmp(way, "waterpark") == 0) return PT_WATERPARK;
  if (strcmp(way, "stadium") == 0) return PT_STADIUM;
  if (strcmp(way, "parking") == 0) return PT_PARKING;
  if (strcmp(way, "cemetery") == 0) return PT_CEMETERY;
  if (strcmp(way, "sand") == 0) return PT_SAND;
  if (strcmp(way, "park") == 0) return PT_PARK;
  if (strcmp(way, "farm") == 0) return PT_FARM;
  if (strcmp(way, "orchard") == 0) return PT_ORCHARD;
  if (strcmp(way, "powerstation") == 0) return PT_POWERSTATION;
  if (strcmp(way, "forest") == 0) return PT_FOREST;
  if (strcmp(way, "industrial") == 0) return PT_INDUSTRIAL;
  if (strcmp(way, "commercial") == 0) return PT_COMMERCIAL;
  if (strcmp(way, "residence") == 0) return PT_RESIDENTIAL;
  if (strcmp(way, "sea") == 0) return PT_SEA;

  if (strcmp(way, "route") == 0) return (maptypes)PS_ROUTE;

  return (maptypes)-1;
}

map_style *mapstyle_get(const char *name)
{
  int i;
  int zoom=0, way=0, font=0, turn=0;
  char s[255];
  FILE *f;
  map_style *style = (map_style *)malloc(sizeof(map_style));
  memset(style, 0, sizeof(map_style));

  snprintf(s, sizeof(s), "%s/themes/%s/map.style", config->datadir, name);
  if ((f = fopen(s, "r"))==NULL)
    return NULL;
  while (!feof(f))
  {
    if (fgets(s, sizeof(s), f) == NULL)
      break;
    if (s[0] == 0)
      continue;
    if (s[0] == '#')
      continue;

    //parse command
    char *cmd, *value;
    cmd = strtok(s, "= \n\r");
    if (cmd == NULL)
      continue;
    value = strtok(NULL, "= \n\r");

    //check
    if (strcmp(cmd, "routewidth") == 0)
    {
      style->routewidth = strlong(value);
    }
    else if (strcmp(cmd, "touristwidth") == 0)
    {
      style->touristwidth = strlong(value);
    }
    else if (strcmp(cmd, "zoom") == 0)
    {
      zoom = strlong(value);
    }
    else if (strcmp(cmd, "type") == 0)
    {
      way = gettype(value);
      //printf("%s\n", value);
    }
    else if (strcmp(cmd, "fontindex") == 0)
    {
      font = atoi(value)-1;
      style->font[font] = (map_fontstyle*)malloc(sizeof(map_fontstyle));
      style->font[font]->name = NULL;
      style->font[font]->size = 0;
    }
    else if (strcmp(cmd, "turnindex") == 0)
      turn = atoi(value);
    else if (strcmp(cmd, "enable") == 0)
      style->zoom[zoom].ways[way].enable = strlong(value);
    else if (strcmp(cmd, "text") == 0)
      style->zoom[zoom].ways[way].text = strlong(value);
    else if (strcmp(cmd, "color") == 0)
    {
      if (zoom>0)
      {
        if (way==PS_ROUTE)
          style->zoom[zoom].nav.color = strlong(value);
        else
          style->zoom[zoom].ways[way].color = strlong(value);
      }
      else
      {
        for (i=0; i<mapzooms; i++)
        {
          if (way==PS_ROUTE)
            style->zoom[i].nav.color = strlong(value);
          else
            style->zoom[i].ways[way].color = strlong(value);
        }
      }
    }
    else if (strcmp(cmd, "textcolor") == 0)
    {
      if (zoom>0)
      {
        style->zoom[zoom].ways[way].textcolor = strlong(value);
      }
      else
      {
        for (i=0; i<mapzooms; i++)
          style->zoom[i].ways[way].textcolor = strlong(value);
      }
    }
    else if (strcmp(cmd, "width") == 0)
    {
      if (zoom>0)
      {
        if (way==PS_ROUTE)
          style->zoom[zoom].nav.width = strlong(value);
        else
          style->zoom[zoom].ways[way].width = strlong(value);
      }
      else
      {
        for (i=0; i<mapzooms; i++)
        {
          long w = strlong(value)/(1<<i);
          if ((way==PS_ROUTE) && (w<5))
            w=5;
          else if (w<2)
            w=2;
          //printf("Way %d zoom %d width %ld\n", way, i, w);
          if (way<0)
            style->zoom[i].nav.width = w;
          else
            style->zoom[i].ways[way].width = w;
        }
      }
    }
    else if (strcmp(cmd, "font") == 0)
    {
      int fontindex = atoi(value);
      if (zoom>0)
      {
        style->zoom[zoom].ways[way].font = fontindex;
      }
      else
      {
        for (i=0; i<mapzooms; i++)
        {
          style->zoom[i].ways[way].font = fontindex;
        }
      }
    }
    else if (strcmp(cmd, "fontname") == 0)
    {
      int fontlen = strlen(value)+1;
      style->font[font]->name = (char*)malloc(fontlen);
      strcpy(style->font[font]->name, value);
    }
    else if (strcmp(cmd, "fontsize") == 0)
    {
      style->font[font]->size = strlong(value);
    }
    else if (strcmp(cmd, "icon") == 0)
    {
      char icon[255];
      snprintf(icon, sizeof(icon), "%s/themes/%s/%s", config->datadir, name, value);
      //printf("%s\n", icon);
      int iconlen = strlen(icon)+1;
      if (zoom>0)
      {
        style->zoom[zoom].ways[way].icon = (char*)malloc(iconlen);
        strcpy(style->zoom[zoom].ways[way].icon, icon);
      }
      else
      {
        for (i=0; i<mapzooms; i++)
        {
          style->zoom[i].ways[way].icon = (char*)malloc(iconlen);
          strcpy(style->zoom[i].ways[way].icon, icon);
        }
      }
    }
    else if (strcmp(cmd, "pointer") == 0)
    {
      char ptr[255];
      snprintf(ptr, sizeof(ptr), "%s/themes/%s/%s", config->datadir, name, value);
      //printf("%s\n", ptr);
      int len = strlen(ptr)+1;
      style->pointer = (char*)malloc(len);
      strcpy(style->pointer, ptr);
    }
    else if (strcmp(cmd, "turn") == 0)
    {
      if (turn<cntroutedir)
      {
        char ptr[255];
        snprintf(ptr, sizeof(ptr), "%s/themes/%s/%s", config->datadir, name, value);
        //printf("%s\n", ptr);
        int len = strlen(ptr)+1;
        style->turn[turn] = (char*)malloc(len);
        strcpy(style->turn[turn], ptr);
      }
    }
  }
  fclose(f);
  return style;
}

void mapstyle_free(map_style *style)
{
  int i;
  if (style == NULL)
    return;
  for (i=0; i<mapzooms; i++)
  {
    int j;
    for (j=0; j<maxmaptypes; j++)
    {
      if (style->zoom[i].ways[j].icon)
        free(style->zoom[i].ways[j].icon);
    }
  }
  free(style);
}
