/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_styles.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MAPSTYLES_H
#define _MAPSTYLES_H

#include <map.h>
#include "route.h"

#define mapzooms 32
#define mapfonts 10

typedef struct
{
  int enable;  //not used yet
  unsigned long color;
  int width;
} map_navstyle;

typedef struct
{
  int enable;          //enable drawing
  int text;            //enable text drawing
  long color;          //color of drawing
  long textcolor;      //color of text
  int width;           //width of line
  char *icon;          //filename of icon
  int font;            //font index to use
} map_waystyle;

typedef struct
{
  map_waystyle ways[cntmaptypes];
  map_navstyle nav;
} map_zoomstyle;

typedef struct
{
  char *name;
  int size;
} map_fontstyle;

typedef struct
{
  char name[20];
  int routewidth;
  int touristwidth;
  char *pointer;
  map_zoomstyle zoom[mapzooms];
  map_fontstyle *font[mapfonts];
  char *turn[cntroutedir];
} map_style;

map_style *mapstyle_get(const char *name);
void mapstyle_free(map_style *style);

#endif
