/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * mcconf.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MCCONF_H
#define _MCCONF_H

#include "route.h"

typedef struct
{
  char *datadir;
  char *map;

  map_position home;

  //routing
  routing_vehicle route_vehicle;
  routing_mode route_mode;
  routing_add route_add;
  int route_sector;

  //track
  int gpx_log;
  int gpx_decimate;
  int gpx_distance;
  int gpx_angle;
  int gpx_rise;

  //chrono
  int chrono_ena;
  struct timeval chrono_start;
  long chrono_len;

  //cache limits
  long limit_nodes;
  long limit_planes;
  long limit_pois;
  long limit_locs;
  long limit_text;
  long limit_endnodes;
  long limit_visited;  //currently not used

  //directories
  char *dir_tracks;
  char *dir_routes;

  //sounds
  char *sounds_cmd;
  char *sounds_style;
} mcconf;

extern mcconf *config;

int conf_init(int argc, char **argv);
int conf_deinit(void);


#endif
