/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * route_sector.h
 * Copyright (C) Mike Crash 2011 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _ROUTESECTOR_H
#define _ROUTESECTOR_H

#include "route_common.h"

//node cross
typedef struct
{
  long id;              //id of connected node
  maptypes waytype;
  int speed;
  unsigned int flags;
} routecross;

void route_sector_init(routing_vehicle vehicle, routing_mode mode);
void route_sector_deinit();
int route_nodeposition(long id, map_position *loc, map_position *pos);
int route_nodecross(long id, map_position *loc, int *count, routecross **cross);
int route_sector_append(route_node *node, route_endnodes *endnodes);

#endif
