/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * sounds.h
 * Copyright (C) Mike Crash 2011 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MCSOUNDS_H
#define _MCSOUNDS_H

//sound route directions have to be same as turn directions
typedef enum
{
  sound_none,
  sound_straight,
  sound_r_uturn,
  sound_l_uturn,
  sound_hardleft, 
  sound_left,
  sound_softleft,
  sound_softright,
  sound_right,
  sound_hardright,
  sound_rr_straight,
  sound_rr_uturn,
  sound_rr_hardleft,
  sound_rr_left,
  sound_rr_softleft,
  sound_rr_softright,
  sound_rr_right,
  sound_rr_hardright,
  sound_rl_straight,
  sound_rl_uturn,
  sound_rl_hardleft,
  sound_rl_left,
  sound_rl_softleft,
  sound_rl_softright,
  sound_rl_right,
  sound_rl_hardright,
  sound_direction,
  sound_waypoint,
  sound_finish,

  sound_in50m,
  sound_in100m,
  sound_in200m,
  sound_in1km,
  sound_andjustafter,
  sound_leavedtheroute
} sounds_type;

#define sounds_type_count (sound_leavedtheroute+1)

int sounds_init(char *style);
int sounds_play(sounds_type *sound, int count);
int sounds_deinit();

#endif
