/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_address.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "map_common.h"
#include "map_address.h"

int map_address_init(void)
{
  map_part part;
  map_lock(map);
  //check countries
  fseek(map->f, map->info.countries, SEEK_SET);
  map_readpart(&part);
  if (part.partid == MPID_COUNTRIES)
  {
    map->address.countries_count = part.count;
  }
  else
  {
    map->address.countries_count = 0;
    return -1;
  }
  //printf("Countries: %ld\n", map->address.countries_count);
  //check cities
  //printf("Cities: %lx\n", map->info.cities);
  fseek(map->f, map->info.cities, SEEK_SET);
  map_readpart(&part);
  if (part.partid != MPID_CITIES)
  {
    map_unlock(map);
    return -1;
  }
  //check streets
  //printf("Streets: %lx\n", map->info.streets);
  fseek(map->f, map->info.streets, SEEK_SET);
  map_readpart(&part);
  if (part.partid != MPID_STREETS)
  {
    map_unlock(map);
    return -1;
  }
  //check address
  fseek(map->f, map->info.addresses, SEEK_SET);
  map_readpart(&part);
  if (part.partid != MPID_ADDRESSES)
  {
    map_unlock(map);
    return -1;
  }
  map_unlock(map);
  return 0;
}

int map_address_clear(void)
{
  return 0;
}