/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_country.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>
#include "functions.h"
#include "countries.h"
#include "map_country.h"
#include "map_common.h"
#include "typeio.h"
#include "diacritics.h"


mapaddrsearch *map_country_start(char *name)
{
  mapaddrsearch *as = (mapaddrsearch *)malloc(sizeof(mapaddrsearch)+strlen(name)+1);
  as->type = MAS_COUNTRY;
  as->filepos = map->info.countries + map_part_size;
  strcpy(as->name, name);
  as->index = 0;
  return as;
}

tcountry *map_country_get(mapaddrsearch *as)
{
  map_lock(map);
  fseek(map->f, as->filepos, SEEK_SET);
  while (as->index < map->address.countries_count)
  {
    long id, citiesfilepos;
    fread_long(&id, 1, map->f);
    fread_long(&citiesfilepos, 1, map->f);
    as->filepos += map_country_size;

    const char *name = country_code2name(id);
    int l = strlen(name) + 1;
    char *uname = (char *)malloc(l);
    utf8_to_ascii(name, uname);
    as->index++;
    
    if ((strlen(as->name) == 0) || (strcasepos(uname, as->name) == 0))
    {
      map_unlock(map);
      free(uname);
      tcountry *tc = (tcountry *)malloc(sizeof(tcountry) + l);
      tc->id = id;
      tc->citiesfilepos = citiesfilepos;
      strcpy(tc->name, name);
      return tc;
    }
  }
  map_unlock(map);
  return NULL;
}

void map_country_stop(mapaddrsearch *as)
{
  if (as)
  {
    free(as);
  }
}

