/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_index.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPINDEX_H
#define _MCMAPINDEX_H

#define indexcachesize 1000

typedef struct
{
  long id;
  long filepos;
} mapindex;

typedef struct mapindexcache
{
  long count;                    //count of cached indexes in this page
  struct mapindexcache *next;    //pointer to next cache page
  mapindex *index;               //index
} mapindexcache;

//read index from map
//currently it reads the whole index
//TODO add requested part based on requested ID
mapindexcache *map_indexread(char partid, long id, mapindexcache *cache);
mapindexcache * map_indexclear(mapindexcache *cache);
long map_indexfilepos(mapindexcache *cache, long id);


#endif