/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_poi.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPLOCS_H
#define _MCMAPLOCS_H

#include <map.h>

typedef struct
{
  long lat1;
  long lon1;
  long lat2;
  long lon2;
  maptypes loctype;
  int check;
  int checked;
  void *sector;
  void *loc;
} maplocsearch;

int map_locs_init(void);
int map_locs_clear(void);

maplocsearch *map_locs_start(long lat1, long lon1, long lat2, long lon2);
void map_locs_type(maplocsearch *ps, maptypes loctype);
mloc *map_locs_get(maplocsearch *ps);
int map_locs_stop(maplocsearch *ps);


#endif
