/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_planes.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPPLANES_H
#define _MCMAPPLANES_H

#include <map.h>

typedef struct
{
  long lat1;
  long lon1;
  long lat2;
  long lon2;
  maptypes planetype;
  int check;
  int checked;
  void *sector;
  void *plane;
} mapplanesearch;

int map_planes_init(void);
int map_planes_clear(void);

mapplanesearch *map_planes_start(long lat1, long lon1, long lat2, long lon2);
void map_planes_type(mapplanesearch *ps, maptypes planetype);
mplane *map_planes_get(mapplanesearch *ps);
int map_planes_stop(mapplanesearch *ps);

#endif
