/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * db_mysql.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DBMYSQL_H
#define _DBMYSQL_H

#if defined(WIN32)
#include <winsock.h>
#endif

#include <mysql.h>

typedef MYSQL_RES sql_result;
typedef MYSQL_ROW sql_row;

int sql_connect(const char *server, const char *user, const char *password, const char *db);
int sql_init(const char *schema);
int sql_query(const char *sql);
sql_result *sql_storeresult();
sql_result *sql_useresult();

sql_row sql_fetch_row(sql_result *result);
unsigned long *sql_fetch_lengths(sql_result *result);

int sql_numrows(sql_result *result);
int sql_affectedrows(void);
unsigned long long sql_insertid();

char *sql_record_str(sql_row record, int index);
char sql_record_char(sql_row record, int index);
int sql_record_int(sql_row record, int index);
long sql_record_long(sql_row record, int index);
long long sql_record_longlong(sql_row record, int index);

int sql_freeresult(sql_result *result);
int sql_close();
int sql_escape(const char *from, char *to, unsigned long len);

#endif
