/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_boundary.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPCREATEBOUNDARY_H
#define _MCMAPCREATEBOUNDARY_H

#include "map.h"

typedef enum
{
  BT_COUNTRY,
  BT_STATE,
  BT_REGION,
  BT_DISTRICT,
  BT_CITY,
  BT_TRAFFIC_CITYLIMIT,
  BT_ERROR = -1
} boundary_type;

#define bounderytypes (BT_TRAFFIC_CITYLIMIT+1)

typedef struct
{
  long id;                        //relation id
  boundary_type type;             //country/city
  int country;                    //country id for BT_COUNTRY
  char *name;                     //name of boundary
  long lat1, lon1, lat2, lon2;    //rectangle for faster lookup
  map_multipolygon *mp;
} boundary;

boundary* map_boundaryinside(map_position *pos, boundary_type type);

int map_loadboundaries(char *filename);
int map_saveboundary(char *filename, boundary_type type);
int map_process_boundaries();
int map_freeboundary(boundary *bnd);
int map_process_citylimit();

#endif
