/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_common.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <stdlib.h>
#include <typeio.h>
#include <stdarg.h>
#include <string.h>

#include <map.h>
#include "map_common.h"

char *curmapname = NULL;
char *logname = NULL;
logtype logwhat = LOG_DEBUG;
omconf *config = NULL;

int map_log(logtype type, const char *s, ...)
{
  FILE *logfile;
  va_list ap;
  if (logname==NULL)
    return 0;
  if (type>logwhat)
    return 0;
  logfile = fopen(logname, "a");
  if (logfile == NULL)
    return -1;
  va_start(ap, s);
  vfprintf(logfile, s, ap);
  va_end(ap);
  fclose(logfile);
  return 0;
}

int conf_init(int argc, char **argv)
{
  config = (omconf *)malloc(sizeof(omconf));
  memset(config, 0, sizeof(omconf));
  return 0;
}

int conf_deinit(void)
{
  if (config)
    return -1;
  free(config);
  config = NULL;
  return 0;
}

