/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPCREATECOMMON_H
#define _MCMAPCREATECOMMON_H

#include <stdio.h>
#include <map.h>
#include "map_nodes.h"
#include "map_relation.h"
#include "map_boundary.h"

#define SQLCHUNK 1000

typedef enum
{
  LOG_NONE,
  LOG_ERROR,
  LOG_WARNING,
  LOG_INFO,
  LOG_DEBUG
} logtype;

typedef struct
{
  int residential_citylimit;
} omconf;

extern map_info mapinfo;
extern long map_written;
extern char *curmapname;
extern char *logname;
extern logtype logwhat;
extern omconf *config;

int map_write_part(FILE *f, char partid, long count);
int map_log(logtype type, const char *s, ...);
int conf_init(int argc, char **argv);
int conf_deinit(void);

#endif
