/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_relation.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPCREATERELATION_H
#define _MCMAPCREATERELATION_H

#define RIT_NODE 1
#define RIT_WAY 2
#define RIT_RELATION 3

#define RIR_SUBAREA 1
#define RIR_INNER 2
#define RIR_OUTER 3
#define RIR_ADMINCENTER 4
#define RIR_FROM 5
#define RIR_TO 6
#define RIR_VIA 7

#define RELT_MULTIPOLYGON 1
#define RELT_BOUNDARY 2
#define RELT_RESTRICTION 3
#define RELT_ROUTE 4
#define RELT_ENFORCEMENT 5

typedef struct
{
  char type;   //RIT_....
  char role;   //RIR_....
  long long id;
} relation_member;

typedef struct
{
  long long id;
  long count;
  relation_member members[];
} osm_relation;

typedef struct
{
  long long id;           //id of node
	unsigned int flags;
  long count;
  long long nodes[];
} osm_restriction;

/*
typedef struct relation_block
{
  int count;
  relation_member items[RELCACHEBLOCK];
  struct relation_block *next;  //pointer to next relation block
} relation_block;

typedef struct relation
{
  long id;
  char type;  //RELT_....
  osm_tags *tags;
  int count;
  relation_block *block;
  relation_block *blockcur;
  struct relation *next;  //pointer to next relation
} osm_relation;

extern osm_relation *map_relation;
*/

char map_relation_type(const char *s);
char map_relation_member(const char *s);
char map_relation_role(const char *s);

int map_getrelation(long long id, osm_relation **relation);
int map_getrelationtag_str(long long id, const char *name, char **value);
int map_getrelationtag_longlong(long long id, const char *name, long long *value);
int map_getrelationtag_int(long long id, const char *name, int *value);
map_tags *map_getrelationtags(long long id);

int relation_multipolygon(osm_relation *rel, map_multipolygon **multipolygon);
int map_process_relations();

#endif
