/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_tags.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPCREATETAGS_H
#define _MCMAPCREATETAGS_H

#include "map.h"

typedef struct
{
  char *name;
  char *value;
} map_tag;

typedef struct
{
  int count;
  map_tag tags[];
} map_tags;

//direct from database
int get_tag_str(const char *table, long long id, const char *name, char **value);
int get_tag_longlong(const char *table, long long id, const char *name, long long *value);
int get_tag_int(const char *table, long long id, const char *name, int *value);

//complete tags
map_tags *get_tags(const char *table, long long id);
char *tag_str(map_tags *tags, const char *name);
void free_tags(map_tags *tags);

#endif
