/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_text.c
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 *
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "map_text.h"
#include "db_mysql.h"

long textsize = 0;

long update_textsize()
{
  long res = 0;
  char sql[100];

  sprintf(sql, "SELECT id,pos,name FROM mcm_text ORDER BY ID DESC LIMIT 0,1");
  if (sql_query(sql) != 0)
  {
    return 0;
  }

  sql_result *result;
  if ((result = sql_storeresult()) == NULL)
  {
    return 0;
  }

  sql_row row;
  if ((row = sql_fetch_row(result)) != NULL)
  {
    int id = sql_record_int(row, 0);
    int pos = sql_record_int(row, 1);
    char *s = sql_record_str(row, 2);
    res = pos + map_text_size + strlen(s)+1;
  }
  sql_freeresult(result);
  return res;
}

long gettextid(char *name)
{
  //check name
  if (name == NULL)
    return 0;
  
  //get text from DB
  long len = (long)strlen(name);
  if (len==0)
    return 0;

  if (textsize == 0)
    textsize = update_textsize();

  char *sql = (char *)malloc(len*2 + 200);
  char *name2 = (char*)malloc(len*2+1);
  sql_escape(name, name2, len);
  sprintf(sql, "SELECT id FROM mcm_text WHERE name='%s' COLLATE 'utf8_bin' LIMIT 0,1", name2);
  if (sql_query(sql) != 0)
  {
    free(name2);
    free(sql);
    return 0;
  }

  sql_result *result;
  if ((result = sql_storeresult()) == NULL)
  {
    free(name2);
    free(sql);
    return 0;
  }

  sql_row row;
  if ((row = sql_fetch_row(result)) != NULL)
  {
    int id = sql_record_int(row, 0);
    free(name2);
    free(sql);
    sql_freeresult(result);
    return id;
  }
  sql_freeresult(result);
  
  //insert into DB
  long pos = textsize;
  sprintf(sql, "INSERT INTO mcm_text (pos, name) VALUES (%ld, '%s')", pos, name2);
  if (sql_query(sql) != 0)
    return 0;
  long id = (long)sql_insertid();
  free(name2);
  free(sql);
  textsize += map_text_size + len + 1;
  return id;
}

long gettextpos(long id)
{
  long filepos = 0;
  
  char sql[100];
  sprintf(sql, "SELECT pos FROM mcm_text WHERE id=%ld", id);
  if (sql_query(sql) != 0)
  {
    return 0;
  }

  sql_result *result;
  if ((result = sql_storeresult()) == NULL)
  {
    return 0;
  }

  sql_row row;
  if ((row = sql_fetch_row(result)) != NULL)
  {
    filepos = sql_record_int(row, 0);
  }

  sql_freeresult(result);
  return filepos;
}
