/* -*- Mode: C; indent-tabs-mode: s; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * map_osmway.h
 * Copyright (C) Mike Crash 2009 <mike@mikecrash.com>
 * 
 * main.c is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.c is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _MCMAPCREATEWAYS_H
#define _MCMAPCREATEWAYS_H

#include "polygon.h"
#include "map_tags.h"

typedef struct
{
  long long id;
  long count;
  long long nodes[];
} osm_way;

int map_getway(long long id, osm_way **way);
int way2polygon(osm_way *way, map_polygon **polygon);
map_tags *map_getwaytags(long long id);
int map_wayarea(osm_way *way, long *lat1, long *lon1, long *lat2, long *lon2);
map_multipolygon *map_waymultipolygon(long long id);

int map_process_ways();

#endif
